Кластер [cluster.x-k8s.io/v1beta1]
- Description
- Cluster is the Schema for the clusters API.
- Type
object
Specification
.spec
- Description
- spec is the desired state of Cluster.
- Type
object
.spec.availabilityGates
- Description
- availabilityGates specifies additional conditions to include when evaluating Cluster Available condition. If this field is not defined and the Cluster implements a managed topology, availabilityGates from the corresponding ClusterClass will be used, if any. NOTE: this field is considered only for computing v1beta2 conditions.
- Type
array
.spec.availabilityGates[]
- Description
- ClusterAvailabilityGate contains the type of a Cluster condition to be used as availability gate.
- Type
object- Required
conditionType
.spec.clusterNetwork
- Description
- clusterNetwork represents the cluster network configuration.
- Type
object
.spec.clusterNetwork.pods
- Description
- pods is the network ranges from which Pod networks are allocated.
- Type
object- Required
cidrBlocks
.spec.clusterNetwork.pods.cidrBlocks
- Description
- cidrBlocks is a list of CIDR blocks.
- Type
array
.spec.clusterNetwork.pods.cidrBlocks[]
- Type
string
.spec.clusterNetwork.services
- Description
- services is the network ranges from which service VIPs are allocated.
- Type
object- Required
cidrBlocks
.spec.clusterNetwork.services.cidrBlocks
- Description
- cidrBlocks is a list of CIDR blocks.
- Type
array
.spec.clusterNetwork.services.cidrBlocks[]
- Type
string
.spec.controlPlaneEndpoint
- Description
- controlPlaneEndpoint represents the endpoint used to communicate with the control plane.
- Type
object- Required
hostport
.spec.controlPlaneRef
- Description
- controlPlaneRef is an optional reference to a provider-specific resource that holds the details for provisioning the Control Plane for a Cluster.
- Type
object
.spec.infrastructureRef
- Description
- infrastructureRef is a reference to a provider-specific resource that holds the details for provisioning infrastructure for a cluster in said provider.
- Type
object
.spec.topology
- Description
- topology encapsulates the topology for the cluster. NOTE: It is required to enable the ClusterTopology feature gate flag to activate managed topologies support; this feature is highly experimental, and parts of it might still be not implemented.
- Type
object- Required
classversion
.spec.topology.controlPlane
- Description
- controlPlane describes the cluster control plane.
- Type
object
.spec.topology.controlPlane.machineHealthCheck
- Description
- machineHealthCheck allows to enable, disable and override the MachineHealthCheck configuration in the ClusterClass for this control plane.
- Type
object
.spec.topology.controlPlane.machineHealthCheck.remediationTemplate
- Description
- remediationTemplate is a reference to a remediation template provided by an infrastructure provider. This field is completely optional, when filled, the MachineHealthCheck controller creates a new object from the template referenced and hands off remediation of the machine to a controller that lives outside of Cluster API.
- Type
object
.spec.topology.controlPlane.machineHealthCheck.unhealthyConditions
- Description
- unhealthyConditions contains a list of the conditions that determine whether a node is considered unhealthy. The conditions are combined in a logical OR, i.e. if any of the conditions is met, the node is unhealthy.
- Type
array
.spec.topology.controlPlane.machineHealthCheck.unhealthyConditions[]
- Description
- UnhealthyCondition represents a Node condition type and value with a timeout specified as a duration. When the named condition has been in the given status for at least the timeout value, a node is considered unhealthy.
- Type
object- Required
statustimeouttype
.spec.topology.controlPlane.readinessGates
- Description
- readinessGates specifies additional conditions to include when evaluating Machine Ready condition. This field can be used e.g. to instruct the machine controller to include in the computation for Machine's ready computation a condition, managed by an external controllers, reporting the status of special software/hardware installed on the Machine. If this field is not defined, readinessGates from the corresponding ControlPlaneClass will be used, if any. NOTE: This field is considered only for computing v1beta2 conditions. NOTE: Specific control plane provider implementations might automatically extend the list of readinessGates; e.g. the kubeadm control provider adds ReadinessGates for the APIServerPodHealthy, SchedulerPodHealthy conditions, etc.
- Type
array
.spec.topology.controlPlane.readinessGates[]
- Description
- MachineReadinessGate contains the type of a Machine condition to be used as a readiness gate.
- Type
object- Required
conditionType
.spec.topology.controlPlane.variables
- Description
- variables can be used to customize the ControlPlane through patches.
- Type
object
.spec.topology.controlPlane.variables.overrides
- Description
- overrides can be used to override Cluster level variables.
- Type
array
.spec.topology.controlPlane.variables.overrides[]
- Description
- ClusterVariable can be used to customize the Cluster through patches. Each ClusterVariable is associated with a Variable definition in the ClusterClass `status` variables.
- Type
object- Required
namevalue
.spec.topology.variables
- Description
- variables can be used to customize the Cluster through patches. They must comply to the corresponding VariableClasses defined in the ClusterClass.
- Type
array
.spec.topology.variables[]
- Description
- ClusterVariable can be used to customize the Cluster through patches. Each ClusterVariable is associated with a Variable definition in the ClusterClass `status` variables.
- Type
object- Required
namevalue
.spec.topology.workers
- Description
- workers encapsulates the different constructs that form the worker nodes for the cluster.
- Type
object
.spec.topology.workers.machineDeployments
- Description
- machineDeployments is a list of machine deployments in the cluster.
- Type
array
.spec.topology.workers.machineDeployments[]
- Description
- MachineDeploymentTopology specifies the different parameters for a set of worker nodes in the topology. This set of nodes is managed by a MachineDeployment object whose lifecycle is managed by the Cluster controller.
- Type
object- Required
classname
.spec.topology.workers.machineDeployments[].machineHealthCheck
- Description
- machineHealthCheck allows to enable, disable and override the MachineHealthCheck configuration in the ClusterClass for this MachineDeployment.
- Type
object
.spec.topology.workers.machineDeployments[].machineHealthCheck.remediationTemplate
- Description
- remediationTemplate is a reference to a remediation template provided by an infrastructure provider. This field is completely optional, when filled, the MachineHealthCheck controller creates a new object from the template referenced and hands off remediation of the machine to a controller that lives outside of Cluster API.
- Type
object
.spec.topology.workers.machineDeployments[].machineHealthCheck.unhealthyConditions
- Description
- unhealthyConditions contains a list of the conditions that determine whether a node is considered unhealthy. The conditions are combined in a logical OR, i.e. if any of the conditions is met, the node is unhealthy.
- Type
array
.spec.topology.workers.machineDeployments[].machineHealthCheck.unhealthyConditions[]
- Description
- UnhealthyCondition represents a Node condition type and value with a timeout specified as a duration. When the named condition has been in the given status for at least the timeout value, a node is considered unhealthy.
- Type
object- Required
statustimeouttype
.spec.topology.workers.machineDeployments[].readinessGates
- Description
- readinessGates specifies additional conditions to include when evaluating Machine Ready condition. This field can be used e.g. to instruct the machine controller to include in the computation for Machine's ready computation a condition, managed by an external controllers, reporting the status of special software/hardware installed on the Machine. If this field is not defined, readinessGates from the corresponding MachineDeploymentClass will be used, if any. NOTE: This field is considered only for computing v1beta2 conditions.
- Type
array
.spec.topology.workers.machineDeployments[].readinessGates[]
- Description
- MachineReadinessGate contains the type of a Machine condition to be used as a readiness gate.
- Type
object- Required
conditionType
.spec.topology.workers.machineDeployments[].strategy
- Description
- strategy is the deployment strategy to use to replace existing machines with new ones.
- Type
object
.spec.topology.workers.machineDeployments[].strategy.remediation
- Description
- remediation controls the strategy of remediating unhealthy machines and how remediating operations should occur during the lifecycle of the dependant MachineSets.
- Type
object
.spec.topology.workers.machineDeployments[].strategy.rollingUpdate
- Description
- rollingUpdate is the rolling update config params. Present only if MachineDeploymentStrategyType = RollingUpdate.
- Type
object
.spec.topology.workers.machineDeployments[].variables
- Description
- variables can be used to customize the MachineDeployment through patches.
- Type
object
.spec.topology.workers.machineDeployments[].variables.overrides
- Description
- overrides can be used to override Cluster level variables.
- Type
array
.spec.topology.workers.machineDeployments[].variables.overrides[]
- Description
- ClusterVariable can be used to customize the Cluster through patches. Each ClusterVariable is associated with a Variable definition in the ClusterClass `status` variables.
- Type
object- Required
namevalue
.spec.topology.workers.machinePools
- Description
- machinePools is a list of machine pools in the cluster.
- Type
array
.spec.topology.workers.machinePools[]
- Description
- MachinePoolTopology specifies the different parameters for a pool of worker nodes in the topology. This pool of nodes is managed by a MachinePool object whose lifecycle is managed by the Cluster controller.
- Type
object- Required
classname
.spec.topology.workers.machinePools[].failureDomains
- Description
- failureDomains is the list of failure domains the machine pool will be created in. Must match a key in the FailureDomains map stored on the cluster object.
- Type
array
.spec.topology.workers.machinePools[].failureDomains[]
- Type
string
.spec.topology.workers.machinePools[].variables
- Description
- variables can be used to customize the MachinePool through patches.
- Type
object
.spec.topology.workers.machinePools[].variables.overrides
- Description
- overrides can be used to override Cluster level variables.
- Type
array
.spec.topology.workers.machinePools[].variables.overrides[]
- Description
- ClusterVariable can be used to customize the Cluster through patches. Each ClusterVariable is associated with a Variable definition in the ClusterClass `status` variables.
- Type
object- Required
namevalue
.status
- Description
- status is the observed state of Cluster.
- Type
object
.status.conditions
- Description
- conditions defines current service state of the cluster.
- Type
array
.status.conditions[]
- Description
- Condition defines an observation of a Cluster API resource operational state.
- Type
object- Required
lastTransitionTimestatustype
.status.failureDomains
- Description
- failureDomains is a slice of failure domain objects synced from the infrastructure provider.
- Type
object
.status.v1beta2
- Description
- v1beta2 groups all the fields that will be added or modified in Cluster's status with the V1Beta2 version.
- Type
object
.status.v1beta2.conditions
- Description
- conditions represents the observations of a Cluster's current state. Known condition types are Available, InfrastructureReady, ControlPlaneInitialized, ControlPlaneAvailable, WorkersAvailable, MachinesReady MachinesUpToDate, RemoteConnectionProbe, ScalingUp, ScalingDown, Remediating, Deleting, Paused. Additionally, a TopologyReconciled condition will be added in case the Cluster is referencing a ClusterClass / defining a managed Topology.
- Type
array
.status.v1beta2.conditions[]
- Description
- Condition contains details for one aspect of the current state of this API Resource.
- Type
object- Required
lastTransitionTimemessagereasonstatustype
.status.v1beta2.controlPlane
- Description
- controlPlane groups all the observations about Cluster's ControlPlane current state.
- Type
object
.status.v1beta2.workers
- Description
- workers groups all the observations about Cluster's Workers current state.
- Type
object
API Endpoints
The following API endpoints are available:
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clustersDELETE: delete collection of ClusterGET: list objects of kind ClusterPOST: create a new Cluster
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusters/{name}DELETE: delete the specified ClusterGET: read the specified ClusterPATCH: partially update the specified ClusterPUT: replace the specified Cluster
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusters/{name}/statusGET: read status of the specified ClusterPATCH: partially update status of the specified ClusterPUT: replace status of the specified Cluster
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusters
- HTTP method
DELETE- Description
- delete collection of Cluster
- HTTP responses
- HTTP method
GET- Description
- list objects of kind Cluster
- HTTP responses
- HTTP method
POST- Description
- create a new Cluster
- Query parameters
- Body parameters
- HTTP responses
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusters/{name}
- HTTP method
DELETE- Description
- delete the specified Cluster
- Query parameters
- HTTP responses
- HTTP method
GET- Description
- read the specified Cluster
- HTTP responses
- HTTP method
PATCH- Description
- partially update the specified Cluster
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace the specified Cluster
- Query parameters
- Body parameters
- HTTP responses
/apis/cluster.x-k8s.io/v1beta1/namespaces/{namespace}/clusters/{name}/status
- HTTP method
GET- Description
- read status of the specified Cluster
- HTTP responses
- HTTP method
PATCH- Description
- partially update status of the specified Cluster
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace status of the specified Cluster
- Query parameters
- Body parameters
- HTTP responses